using Gtk;
using Sqlite;
using Cairo;

/*
 * Operation : New | Open | Edit
 * */
namespace Society {
	public class Society : Gtk.Window {
		protected string nameSociety;
		protected string idNumber;
		protected string creationDate;
		protected string phone;
		protected string address;
		protected string ZIPCode;
		protected string town;
		protected string country;
		
		protected Sqlite.Database db;
		protected string errMsgDB;
		protected string nameDB;
	
		protected int exec_callback_select(int n_columns, string[] values, string[] column_names) {
			for (int i=0; i<n_columns;i++) {
				print("nom:%s\t valeur:%s\n",column_names[i], values[i]);
			}
			this.nameSociety = values[1];
			this.creationDate = values[2];
			this.idNumber = values[3];
			this.phone = values[4];
			this.address = values[5];
			this.ZIPCode = values[6];
			this.town = values[7];
			this.country = values[8];
			return 0;
		}
		
		public string get_name_db() {
			return this.nameDB;
		}
		
		public bool db_exist() {
			return (this.nameDB != null);
		}
		
		public void set_name_db(string name_db) {
			this.nameDB = name_db;
		}
		
		public Society() {
			this.nameDB = null;
		}
	}//end class Society
	
	public class NewDBSociety: Society {
		private Gtk.Button buttonBrowse;
		private Gtk.Button buttonValidateNewDBSociety;
		private Gtk.Entry entryNameDB;
		
		private Gtk.FileChooserDialog saveDialog;
		
		public Gtk.Button get_button_validate_new_db_Society() {
			return this.buttonValidateNewDBSociety;
		}
		
		public Gtk.Entry get_entry_name_db() {
			return this.entryNameDB;
		}
		
		public int create_table_Society() {
			// create table Society
			var query = "CREATE TABLE Society (id INT PRIMARY KEY NOT NULL, name TEXT, creation_date TEXT, number TEXT, phone INTEGER, address TEXT, ZIP_code INTEGER, town TEXT, country TEXT)";
			int result = this.db.exec(query, null, out errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur: %s\n", errMsgDB);
				return -1;
			}
			print("Creation de la table Society\n");
			// create the one field
			query = "INSERT INTO Society (id) VALUES (1)";
			result = this.db.exec(query, null, out errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur: %s\n", errMsgDB);
				return -1;
			}
			print("Insertion d'un champ dans Society avec id=1\n");
			return 0;
		}
		
		public int create_database(string name_db) {			
			print("Nom : %s\n", name_db);
			
			int result = Sqlite.Database.open (name_db, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %d: %s\n", this.db.errcode(), this.db.errmsg());
				return -1;
			}
			this.nameDB = name_db;
			print("nameDB=%s\n", this.nameDB);
			create_table_Society();
			
			return 0;
		}
		
		public void show_new_Society() {
			this.entryNameDB.grab_focus();
			this.show_all();
		}
		
		public bool save_dialog() {
			bool res=false;
			this.saveDialog = new Gtk.FileChooserDialog(
				"Entrez un nom de fichier", this as Gtk.Window,
				Gtk.FileChooserAction.SAVE,
				"_Cancel", Gtk.ResponseType.CANCEL,
				"_Enregistrer",
				Gtk.ResponseType.ACCEPT
				);
				
			this.saveDialog.set_current_name("Untitled.db");
				
				if (this.saveDialog.run() == Gtk.ResponseType.ACCEPT) {
					this.nameDB = this.saveDialog.get_current_folder().concat(
						"/" , this.saveDialog.get_current_name(),null);
					create_database(this.nameDB);
					res = true;
				}
				
				this.saveDialog.close();
				this.saveDialog.show();
				return res;
		}//end save_dialog
		
		public NewDBSociety() {
			this.title = "Création d'une Base de Donnée";
			this.set_default_size(300, 120);
			this.set_resizable(false);
			this.delete_event.connect(hide_on_delete);
			
			Gtk.Label labelInfo = new Gtk.Label("Entrez le nom de la Base de Donnée ...\n (Il sera enregistré par défaut dans le répertoire courant)");
			this.entryNameDB = new Gtk.Entry();
			this.buttonBrowse = new Gtk.Button.with_label("Parcourir");
			this.buttonValidateNewDBSociety = new Gtk.Button.with_label("Valider");
			
			//Signal Connect
			this.buttonBrowse.clicked.connect ( () => {
				print("Boite de Dialogue pour sauvegarde\n");
				this.save_dialog();
			});
			this.buttonValidateNewDBSociety.clicked.connect( ()=> {
				create_database(this.entryNameDB.get_text());
				this.entryNameDB.set_text("");
				this.hide();
			});
			this.entryNameDB.activate.connect( () => {
				create_database(this.entryNameDB.get_text());
				this.entryNameDB.set_text("");
				this.hide();
			});
			
			var mainBox = new Gtk.Box(Orientation.VERTICAL, 10);
			var buttonBox = new Gtk.Box(Orientation.HORIZONTAL, 20);
			buttonBox.pack_start(this.buttonBrowse, false, false, 20);
			buttonBox.pack_start(this.buttonValidateNewDBSociety, false, false, 10);
			
			mainBox.add(labelInfo);
			mainBox.add(this.entryNameDB);
			mainBox.add(buttonBox);
			this.add(mainBox);
		}
	}//end class NewDBSociety
	
		
	public class OpenDBSociety: Society {
		private Gtk.FileChooserDialog openDialog;

		public Gtk.FileChooserDialog get_open_dialog() {
			return this.openDialog;
		}
		
		public string get_name_Society() {
			return this.nameSociety;
		}
		
		public string get_id_number() {
			return this.idNumber;
		}
		
		public string get_creation_date() {
			return this.creationDate;
		}
		
		public string get_phone() {
			return this.phone;
		}
		
		public string get_address() {
			return this.address;
		}
		
		public string get_ZIP_code() {
			return this.ZIPCode;
		}
		
		public string get_town() {
			return this.town;
		}
		
		public string get_country() {
			return this.country;
		}
		
		public int open_db() {
			int result = Sqlite.Database.open (this.nameDB, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %d: %s\n", this.db.errcode(), this.db.errmsg());
				return -1;
			}
			string query = "SELECT * FROM Society";
			result = this.db.exec(query, exec_callback_select, out this.errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %s\n", this.errMsgDB);
				return -1;
			}
			
			return 0;
		}

		public int open_dialog() {
			this.openDialog = new Gtk.FileChooserDialog(
				"Sélectionner un fichier", this as Gtk.Window, Gtk.FileChooserAction.OPEN,
				"_Cancel", Gtk.ResponseType.CANCEL,
				"_Open", Gtk.ResponseType.ACCEPT
			);
			
			if (this.openDialog.run() == Gtk.ResponseType.ACCEPT) {
				print("Fichier selectionné: %s\n", this.openDialog.get_filename());
				this.nameDB = this.openDialog.get_filename();
				print("Dans open_dialog:\n");
				this.open_db();
			}
			
			this.openDialog.close();
			this.openDialog.show();
			return 0;
		}
		
		public OpenDBSociety() {
			print("Creation objet OpenDBSociety\n");
		}
	}//end class OpenDBSociety

	public class EditSociety: Society {
		private Gtk.Entry entryName;
		private Gtk.Entry entryIDNumber;
		private Gtk.Entry entryCreationDate;
		private Gtk.Entry entryPhone;
		private Gtk.Entry entryAddress;
		private Gtk.Entry entryZIPCode;
		private Gtk.Entry entryTown;
		private Gtk.Entry entryCountry;

		private Gtk.Button buttonValidateEditSociety;

		public Gtk.Button get_button_validate_edit_Society() {
			return this.buttonValidateEditSociety;
		}
		
		public void set_society (	string _nameSociety, string _creationDate,
									string _idNumber, string _phone,
									string _address, string _ZIPCode,
									string _town, string _country ) {
			this.entryName.set_text(_nameSociety);
			this.entryIDNumber.set_text(_idNumber);
			this.entryCreationDate.set_text(_creationDate);
			this.entryPhone.set_text(_phone);
			this.entryAddress.set_text(_address);
			this.entryZIPCode.set_text(_ZIPCode);
			this.entryTown.set_text(_town);
			this.entryCountry.set_text(_country);
		}

		public int set_society_with_path_db(string pathDB) {
			int result = Sqlite.Database.open (pathDB, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %d: %s\n", this.db.errcode(), this.db.errmsg());
				return -1;
			}
			string query = "SELECT * FROM Society";
			result = this.db.exec(query, exec_callback_select, out this.errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %s\n", this.errMsgDB);
				return -1;
			}
			
			this.nameDB = pathDB;
			
			this.entryName.set_text(nameSociety);
			this.entryIDNumber.set_text(idNumber);
			this.entryCreationDate.set_text(creationDate);
			this.entryPhone.set_text(phone);
			this.entryAddress.set_text(address);
			this.entryZIPCode.set_text(ZIPCode);
			this.entryTown.set_text(town);
			this.entryCountry.set_text(country);
			
			return 0;
		}
		
		public string get_name_Society() {
			return this.entryName.get_text();
		}

		public void show_edit_Society() {
			this.show_all();
		}
		
		public int save_Society() {
			print("Nome de la base %s\n", this.nameDB);
			int result = Sqlite.Database.open (this.nameDB, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %d: %s\n", this.db.errcode(), this.db.errmsg());
				return -1;
			}
			var query = "UPDATE Society SET name='"+entryName.get_text()+"', creation_date='"+entryCreationDate.get_text()+"', number='"+entryIDNumber.get_text()+"', phone='"+entryPhone.get_text()+"', address='"+entryAddress.get_text()+"', ZIP_code='"+entryZIPCode.get_text()+"', town='"+entryTown.get_text()+"', country='"+entryCountry.get_text()+"' WHERE id='1'";
			print("Requete : %s\t DB = %s \n", query, this.nameDB);
			result = this.db.exec (query, null, out this.errMsgDB);
			if (result!=Sqlite.OK) {
				stderr.printf("Erreur: %s\n", this.errMsgDB);
				return -1;
			}
			print("Ok requete update\n");
			return 0;
		}
		
		public EditSociety() {
			this.title="Informations Society";
			this.set_default_size(400, -1);
			this.set_resizable(false);
			this.delete_event.connect(hide_on_delete);

			Gtk.Label labelName = new Gtk.Label("Nom : ");
			labelName.set_xalign(0);
			this.entryName = new Gtk.Entry();
			this.entryName.set_hexpand(true);

			Gtk.Label labelIDNumber = new Gtk.Label("Numéro RNA : ");
			labelIDNumber.set_xalign(0);
			this.entryIDNumber = new Gtk.Entry();

			Gtk.Label labelCreationDate = new Gtk.Label("Date de création : ");
			labelCreationDate.set_xalign(0);
			this.entryCreationDate = new Gtk.Entry();

			Gtk.Label labelPhone = new Gtk.Label("Numéro de téléphone : ");
			labelPhone.set_xalign(0);
			this.entryPhone = new Gtk.Entry();

			Gtk.Label labelAddress = new Gtk.Label("Adresse : ");
			labelAddress.set_xalign(0);
			this.entryAddress = new Gtk.Entry();

			Gtk.Label labelZIPCode = new Gtk.Label("Code Postal : ");
			labelZIPCode.set_xalign(0);
			this.entryZIPCode = new Gtk.Entry();

			Gtk.Label labelTown = new Gtk.Label("Ville : ");
			labelTown.set_xalign(0);
			this.entryTown = new Gtk.Entry();

			Gtk.Label labelCountry = new Gtk.Label("Pays : ");
			labelCountry.set_xalign(0);
			this.entryCountry = new Gtk.Entry();

			this.buttonValidateEditSociety = new Gtk.Button.with_label("Enregistrer");
			this.buttonValidateEditSociety.clicked.connect( ()=> {
				this.save_Society();
				this.hide();
			});

			// Grid
			Gtk.Grid grid = new Gtk.Grid();
			grid.set_margin_start(10);
			grid.set_margin_end(10);
			this.add(grid);
			grid.attach(labelName, 0, 0, 1, 1);
			grid.attach(entryName, 1, 0, 1, 1);
			grid.attach(labelIDNumber, 0, 1, 1, 1);
			grid.attach(entryIDNumber, 1, 1, 1, 1);
			grid.attach(labelCreationDate, 0, 2, 1, 1);
			grid.attach(entryCreationDate, 1, 2, 1, 1);
			grid.attach(labelPhone, 0, 3, 1, 1);
			grid.attach(entryPhone, 1, 3, 1, 1);
			grid.attach(labelAddress, 0, 4, 1, 1);
			grid.attach(entryAddress, 1, 4, 1, 1);
			grid.attach(labelZIPCode, 0, 5, 1, 1);
			grid.attach(entryZIPCode, 1, 5, 1, 1);
			grid.attach(labelTown, 0, 6, 1, 1);
			grid.attach(entryTown, 1, 6, 1, 1);
			grid.attach(labelCountry, 0, 7, 1, 1);
			grid.attach(entryCountry, 1, 7, 1, 1);
			grid.attach(buttonValidateEditSociety, 1, 8, 1, 1);
		}
	}//end class EditSociety
	
	public class PDFSociety: Society {
		private Gtk.FileChooserDialog saveDialog;

		public int set_society_with_path_db(string pathDB) {
			int result = Sqlite.Database.open (pathDB, out this.db);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %d: %s\n", this.db.errcode(), this.db.errmsg());
				return -1;
			}
			string query = "SELECT * FROM Society";
			result = this.db.exec(query, exec_callback_select, out this.errMsgDB);
			if (result != Sqlite.OK) {
				stderr.printf("Erreur : %s\n", this.errMsgDB);
				return -1;
			}
			
			this.nameDB = pathDB;
			
			return 0;
		}
		
		public int save_dialog() {
			this.saveDialog = new Gtk.FileChooserDialog(
				"Entrez le nom du fichier", this as Gtk.Window,
				Gtk.FileChooserAction.SAVE,
				"_Cancel", Gtk.ResponseType.CANCEL,
				"_Enregistrer",
				Gtk.ResponseType.ACCEPT
				);
				
				
				if (this.saveDialog.run() == Gtk.ResponseType.ACCEPT) {
					this.nameDB = this.saveDialog.get_current_folder().concat(
						"/" , this.saveDialog.get_current_name(),null);
					save_pdf(this.nameDB);
				}
				
				this.saveDialog.close();
				this.saveDialog.show();
				return 0;
		}//end save_dialog
		
		public int save_pdf(string namePdf) {
			// Size Format A4 200dpi = 1654x2339
			// Size Format A4 100dpi = 827x1170
			// Size Format A4 72dpi = 596x842
			int begin_x = 50;
			int begin_y = 80;
			int spacing = 20;
			double font_size = 14;
			
			Cairo.Surface surface = new PdfSurface (namePdf, 596, 842);
			Cairo.Context context = new Cairo.Context(surface);
			context.set_font_size(font_size);
			
			context.move_to(begin_x, begin_y);
			context.show_text(this.nameSociety);
			
			context.move_to(begin_x + 400, begin_y);
			context.show_text(this.idNumber);
			
			context.move_to(begin_x, begin_y + spacing);
			context.show_text(this.address);
			
			context.move_to(begin_x, begin_y + 2*spacing);
			context.show_text(this.ZIPCode + " " + this.town);
			
			context.move_to(begin_x, begin_y + 3*spacing);
			context.show_text(this.country);
			
			context.show_page();
			
			return 0;
		}
		
		public PDFSociety() {
		}
	}//end class PDFSociety
}//end namespace
