using Gtk;
using Society;

public class Gui:Window {
	private Gtk.MenuBar menuBar;
	private Gtk.MenuItem menuItemFile;
	private Gtk.Menu menuFile;
	private Gtk.MenuItem menuItemQuit;
	
	private Gtk.MenuItem menuItemSociety;
	private Gtk.Menu menuSociety;
	private Gtk.MenuItem menuItemNewDBSociety;
	private Gtk.MenuItem menuItemOpenDBSociety;
	private Gtk.MenuItem menuItemEditDBSociety;
	private Gtk.MenuItem menuItemExportPDF;

	private Gtk.Label labelInfo;
	
	private string pathDBSociety;
		
	public Gui() {
		this.title="test Society";
		this.destroy.connect(Gtk.main_quit);
		
		// MenuBar
		this.menuBar = new Gtk.MenuBar();
		
		//MenuFile
		this.menuItemFile = new Gtk.MenuItem.with_label("Fichier");
		this.menuFile = new Gtk.Menu();
		menuItemFile.set_submenu(this.menuFile);
		this.menuItemQuit = new Gtk.MenuItem.with_label("Quitter");
		menuFile.add(this.menuItemQuit);
		
		//MenuSociety
		this.menuItemSociety = new Gtk.MenuItem.with_label("Société");
		this.menuSociety = new Gtk.Menu();
		this.menuItemSociety.set_submenu(this.menuSociety);
	
		this.menuItemNewDBSociety = new Gtk.MenuItem.with_label("Créer une base de donnée");
		this.menuItemOpenDBSociety = new Gtk.MenuItem.with_label("Ouvrir une base de donnée");
		this.menuItemEditDBSociety = new Gtk.MenuItem.with_label("Modifier la base de donnée");
		this.menuItemEditDBSociety.set_sensitive(false);
		this.menuItemExportPDF = new Gtk.MenuItem.with_label("Exporter en PDF");
		this.menuItemExportPDF.set_sensitive(false);
		
		this.menuSociety.add(this.menuItemNewDBSociety);
		this.menuSociety.add(this.menuItemOpenDBSociety);
		this.menuSociety.add(this.menuItemEditDBSociety);
		this.menuSociety.add(this.menuItemExportPDF);
	
		//Label Info
		this.labelInfo = new Gtk.Label("Pas de DB Society\nVeuillez soit ouvrir ou créer une Société!");
		
		//Signal connect
		this.menuItemQuit.activate.connect (Gtk.main_quit);

		this.menuItemNewDBSociety.activate.connect( () => {
			var newDBSociety = new Society.NewDBSociety();
			var res = newDBSociety.save_dialog();
			if ( res == true ) {
				this.pathDBSociety = newDBSociety.get_name_db();
				this.labelInfo.set_label("Création de la base de donnée");
				this.menuItemEditDBSociety.set_sensitive(true);
				this.menuItemExportPDF.set_sensitive(true);
			} else {
				print("Erreur! Pas de selection\n");
			}
			/*
			this.pathDBSociety = newDBSociety.get_name_db();
			if (this.pathDBSociety !=null) {
				print("Creation DB Society\n");
				this.labelInfo.set_label("Création de la base de donnée");
				this.menuItemEditDBSociety.set_sensitive(true);
				this.menuItemExportPDF.set_sensitive(true);
			} else {
				print("Erreur! Pas de selection\n");
			}
			*/
		});//end new db
		this.menuItemOpenDBSociety.activate.connect( () => {
			var openDBSociety = new Society.OpenDBSociety();
			openDBSociety.open_dialog();
			this.pathDBSociety = openDBSociety.get_name_db();
//			print("Ouverture de la bdd : %s\n", this.pathDBSociety);
			this.labelInfo.set_label("Chargement de la base de donnée:\n"+this.pathDBSociety);
			this.menuItemEditDBSociety.set_sensitive(true);
			this.menuItemExportPDF.set_sensitive(true);
		});//end open db
		this.menuItemEditDBSociety.activate.connect( () => {
			var editDBSociety = new Society.EditSociety();
			editDBSociety.set_society_with_path_db(this.pathDBSociety);
			editDBSociety.show_edit_Society();
		});//end edit db
		this.menuItemExportPDF.activate.connect ( () => {
			var pdfSociety = new Society.PDFSociety();
			if ( pathDBSociety != null ) {
				pdfSociety.set_society_with_path_db(pathDBSociety);
				pdfSociety.save_dialog();
			} else {
				print("Aucune DB Society charge\n");
				this.labelInfo.set_label("Operation impossible.\nVeuillez ouvrir ou créer une Base de Donnée!");
			}
//			pdfSociety.save_pdf("test.pdf");
		});//end export pdf
		
		//placement object
		//menu
		menuBar.add(menuItemFile);
		menuBar.add(menuItemSociety);
		
		// Box
		Gtk.Box mainBox = new Gtk.Box(Gtk.Orientation.VERTICAL, 0);
		mainBox.pack_start(this.menuBar, false, false, 0);
		mainBox.pack_start(this.labelInfo, true, false, 5);
		this.add(mainBox);
	}
	
	public static int main(string[] args) {
		Gtk.init (ref args);
		var gui = new Gui();
		gui.show_all();
		Gtk.main();
		return 0;
	}
}//end class Gui
